/**
 *    @file
 *
 *    @section LICENSE
 *
 *    Copyright 2009 Bayer & Szell OEG
 *
 *    This file is part of secrond.
 *
 *    secrond is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    secrond is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with secrond.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    @section DESCRIPTION
 *
 *    Contains macro definitions.
 */

 
#ifndef MACROS_H
#define	MACROS_H


#include "config.h"


/** First valid second. */
#define SEC_MIN         0
/** Last valid second. */
#define SEC_MAX         59
/** First valid minute. */
#define MIN_MIN         0
/** Last valid minute. */
#define MIN_MAX         59
/** First valid hour. */
#define HOUR_MIN        0
/** Last valid hour. */
#define HOUR_MAX        23
/** First valid day of the month. */
#define MDAY_MIN        1
/** Last valid day of the month. */
#define MDAY_MAX        31


/** Maximum amount of seconds we may lose or win and redo between runs. */
#define TIMECHANGE_MAX  10
/** Maximum amount of characters in one line in the schedule file. */
#define LINE_MAX        1000
/** Maximum amount of characters for values of a time in the schedule file. */
#define TIMES_MAX       200
/** Maximum amount of characters for one entry in a list of values in the schedule file. */
#define ONETIME_MAX     8
/** Temporary buffer size. */
#define TEMP_MAX        100
/** Maximum amount of characters a process ID may possess. */
#define PID_MAX         10
/** Amount of bytes to increase a buffer in one step. */
#define BUFFER_INC      1000
/** Amount of bytes to increase a small buffer in one step. */
#define BUFFER_INC_S    20


/** Defined for easier reading of the writeLog function. */
#define QUIT            1
/** Defined for easier reading of the writeLog function. */
#define NOQUIT          0
/** Defined for easier reading of the writeLog function. */
#define APPEND          1
/** Defined for easier reading of the writeLog function. */
#define NOAPPEND        0


/** Standard input file number. */
#define STDIN           0
/** Standard output file number. */
#define STDOUT          1
/** Standard error file number. */
#define STDERR          2
/** Read end of a pipe. */
#define READ_END        0
/** Write end of a pipe. */
#define WRITE_END       1


/** User ID for the root. */
#define	ROOT_UID        0


/** Used for Boolean type. */
#define TRUE            1
/** Used for Boolean type. */
#define FALSE           0


/** Pseudo Boolean type. */
typedef int Boolean;


#endif
