/**
 *    @file
 *
 *    @section LICENSE
 *
 *    Copyright 2009 Bayer & Szell OEG
 *
 *    This file is part of secrond.
 *
 *    secrond is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    secrond is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with secrond.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    @section DESCRIPTION
 *
 *    Includes an implementation of strlen and other string manipulation
 *    functions.
 */

 
#include "strings.h"


int my_strlen(const char *str) {
    int i = 0;
    
    while (str[i] != '\0') {
        i++;
    }
    return i;
}


int charpos(const char *str, const char c) {
    int i = 0;

    while (str[i] != c) {
        if (str[i] == '\0') {
            return -1;
        }
        i++;
    }
    return i;
}


char * skipWhitespace(char *str) {
    while (str[0] == '\t' || str[0] == ' ') {
        str++;
    }
    return str;
}


char * extractNonWhitespace(char *str, int max, char *dest) {
    int i = 0;
    
    max--;
    while (str[0] != '\t' && str[0] != ' ' && str[0] != '\r' && str[0] != '\n' && str[0] != '\0' && i < max) {
        dest[i] = str[0];
        i++;
        str++;
    }
    dest[i] = '\0';
    return str;
}


void removeTrailingWhitespace(char * str) {
    char * orig;
    
    orig = str;
    while (str[0] != '\n' && str[0] != '\0') {
        str++;
    }
    while ((str[0] == '\t' || str[0] == ' ' || str[0] == '\r' || str[0] == '\n' || str[0] == '\0') && str != orig) {
        str--;
    }
    if (str != orig) {
        str[1] = '\0';
    }
}
